import java.io.*;

public class DemoWriter
{
    public static void fileWriter() throws IOException {
        FileWriter fw = new FileWriter("out.txt");
        fw.write('a');
        fw.write(System.getProperty("line.separator"));
        fw.write("ahoj");
        fw.write("č");
        //fw.flush();
        fw.close();
    }
    
    public static void bufferedWriter() throws IOException {
        FileWriter fw = new FileWriter("out.txt");
        BufferedWriter bw = new BufferedWriter(fw);
        
        bw.write('a');
        bw.newLine();
        bw.write("ahoj");
        bw.write("č");
        //bw.flush();
        bw.close();
    }


    public static void bufferedWriter2() {
        FileWriter fw = null;
        BufferedWriter bw = null;
        try {
            fw = new FileWriter("out.txt");
            bw = new BufferedWriter(fw);
            bw.write('a');
            bw.newLine();
            bw.write("ahoj");
            bw.write("č");
        } catch (IOException ex) {
            ex.printStackTrace();
        } finally {
            if (bw != null) {
                try {
                    bw.close();
                } catch(IOException ex) {
                    ex.printStackTrace();
                }
            }
        }
    }

    public static void bufferedWriter3() {
        try {
            BufferedWriter bw = new BufferedWriter(new FileWriter("out.txt"));
            try {
                bw.write('a');
                bw.newLine();
                bw.write("ahoj");
                bw.write("č");
            } finally {
                bw.close();
            }
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
    
    public static void bufferedWriter4() {
        try (BufferedWriter bw = new BufferedWriter(new FileWriter("out.txt"))) {            
            bw.write('a');
            bw.newLine();
            bw.write("ahoj");
            bw.write("č");
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
    
    public static void bufferedWriter5(Writer writer) {
        BufferedWriter bw = new BufferedWriter(writer);
        try {            
            bw.write('a');
            bw.newLine();
            bw.write("ahoj");
            bw.write("č");
            bw.flush();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
}
